import streetview
from PIL import Image, UnidentifiedImageError
import random

MIN_LAT = 55.7973732
MAX_LAT = 55.8015634
MIN_LON = 37.3833655
MAX_LON = 37.3983216
folder = "images_strogino"
IMAGE_COUNT = 100

panoids_buffer = []

for i in range(IMAGE_COUNT):
    print(f"Progress {i + 1} of {IMAGE_COUNT}")
    while True:
        lat = round(random.uniform(MIN_LAT, MAX_LAT), 7)
        lon = round(random.uniform(MIN_LON, MAX_LON), 7)
        panoids = streetview.panoids(lat=lat, lon=lon)
        if len(panoids) == 0 or panoids[0]["panoid"] in panoids_buffer:
            continue
        try:
            panorama = streetview.download_panorama_v3(panoids[0]['panoid'], zoom=2, disp=False)
            panoids_buffer.append(panoids[0]['panoid'])
        except UnidentifiedImageError:
            continue
        image = Image.fromarray(panorama)
        image.save(f"{folder}/{lat}_{lon}.png")
        break
